unit cardlist;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,Graphics;

type
  TCard = class(TObject)
  private
    fLeft:Integer;
    fTop: Integer;
    fRight: Integer;
    fBottom: Integer;
    fBitmap:TBitmap;
  public
  constructor create(Bitmap : TBitmap);
   property Left: Integer read fLeft write fLeft;
   property Top: Integer read fTop write fTop;
   property Right: Integer read fRight write fRight;
   property Bottom: Integer read fBottom write fBottom;
   property Bitmap: TBitmap read fBitmap write fBitmap;
  end;
  // define the list
  TCardList = class(TObject)
  private
     FInnerList: TList;
     function GetItem(AIndex: Integer): TCard;
     procedure SetItem(Index: Integer; Card: TCard);
     function GetCount: Integer;
  public
   constructor create;
   destructor Destroy; override;
   function add(Card:TCard): integer;
   property Count: Integer read GetCount;
   property Items[AIndex: Integer] : TCard read getitem write SetItem;
  end;

implementation

  constructor TCard.create(Bitmap : TBitmap);
begin
    fBitmap:=Bitmap;
end;

constructor TCardlist.create;
begin
  FInnerList := TList.Create;
end;


procedure TCardList.SetItem(Index: Integer; Card: TCard);
begin
  if Assigned(Card) then
    FInnerList.Items[Index] := Card
end;

function TCardList.GetCount: Integer;
begin
  Result := FInnerList.Count;
end;

destructor TCardList.Destroy;
var
  i                 : Integer;
begin
  if FInnerList.Count > 0 then
  begin
    for i := FInnerList.Count - 1 downto 0 do
    begin
      TObject(FInnerList.Items[i]).Free;
    end;
  end;
  FInnerList.Free;
  inherited;
end;


function TCardlist.add(Card: TCard): integer;
begin
   FInnerList.Add(Card);
end;

function TCardList.GetItem(AIndex: integer): TCard;
var
   tempCard : TCard;
begin
   {tempCard := Items[AIndex];
   tempCard.Right := tempCard.Left + tempCard.Bitmap.Width;
   tempCard.Bottom := tempCard.Top + tempCard.Bitmap.He;}
   Result := TCard(FInnerList.Items[AIndex]);
end;

end.

