unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, math, Menus,lclintf,contnrs,cardlist;

const
  SPIELER_KARTEN_ANZAHL = 6;
  COMPUTER_GEGNER_ANZAHL = 6;

type
  TMAI = array of Integer;
  Kartenbilder = array[1..36] of TBitmap;
  { TForm1 }

  TForm1 = class(TForm)
    Groupbox2: TGroupBox;
    Kartenhand_anzeige: TImage;
    Karten: TGroupBox;
    KarteLegen: TButton;
    KartenNehmen: TButton;
    GegnerNehmen: TButton;
    KartenZiehen: TButton;
    GroupBox1: TGroupBox;
    Image1: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Memo1: TMemo;
    Panel1: TPanel;
    TrumpfTyp: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    ImageList1: TImageList;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    Spiel: TMenuItem;
    Starten: TMenuItem;
    MenuItem3: TMenuItem;
    Beenden: TMenuItem;
    procedure Arrays_Fuellen;
    procedure Karten_zeichnen;
    procedure BeendenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Groupbox2Click(Sender: TObject);
    procedure Groupbox2MouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Karten_austeilen;
    procedure Kartenhand_anzeigeMouseDown(Sender: TOBject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure StartenClick(Sender: TObject);
  private
    { private declarations }
  public
    karten_im_deck : TMAI;
    karten_spieler : TMAI;
    karten_gegner : TMAI;
    trumpf: Integer;
    spieler_am_zug: Integer;
    isCreated : Boolean; //Spielerhand
    isKartenlisteCreated : Boolean;
    fBilder : Kartenbilder;
    Kartenliste : TCardList;
    { public declarations }
  end; 


  
   { TKartenhand }
   
 TKartenhand = class(TCustomControl)
  private
    fBilder : Kartenbilder;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
    function Bild(BildId: Integer): TBitmap;
    Kartenliste : TCardList;
  end;
  
  TMoveBitmap=class
    fLeft:Integer;
    fTop: Integer;
    fRight: Integer;
    fBottom: Integer;
    fBitmap:TBitmap;
  end;
  

  
var
  Form1: TForm1; 
  Spielerhand : TKartenhand;

implementation

uses
   funktionen;

{Panel1 - Spielerhand}



function TKartenhand.Bild(BildId: Integer): TBitmap;
begin
   Result := fBilder[BildId];
end;

constructor TKartenhand.Create(AOwner: TComponent);
var
   i : Integer;

begin
  inherited Create(AOwner);

  for i := 1 to 36 do
  begin
     fBilder[i] := TBitmap.Create;
     fBilder[i].Width:=100;
     fBilder[i].Height:=Form1.Panel1.Height-2;
     fBilder[i].Canvas.Color := clWhite;
     {fBilder[i].Canvas.Brush.Color:=clwhite;
     fBilder[i].Canvas.FillRect(BoundsRect);}
     fBilder[i].Canvas.FillRect(2,2,fBilder[i].Width-2,fBilder[i].Height-2);
     fBilder[i].Canvas.TextOut(3,3,KartenFarbe(i)+' '+KartenWert(i));
     {temp.create(fBilder[i]);
     Kartenliste.Add(temp);}
  end;

end;

procedure Click(Sender: TObject; Button: TMouseButton;
Shift: TShiftState; X, Y: Integer);
begin

end;

destructor TKartenhand.Destroy;
var
   i : Integer;
begin
  for i := 1 to 36 do
  begin
     fBilder[i].Free;
  end;
  inherited Destroy;
end;

procedure TKartenhand.Paint;
var
   temp,temp2,i,Prozent1,Prozent2 : Integer;
   tempObject: TObject;
   tempCard: TCard;
begin
  inherited Paint;

  if Form1.isKartenlisteCreated then
  begin
     Kartenliste.Free;
     Form1.isKartenlisteCreated := false;
  end;
  
     Kartenliste := TCardList.create;
     Form1.isKartenlisteCreated := True;


  temp := 0;
  Prozent1 := 101 div (Length(Form1.karten_spieler)+1);
  temp2 := (Spielerhand.Width + 10) div 101 * (Prozent1-1);

  for i := 0 to Length(Form1.karten_spieler) do
  begin
     tempCard := TCard.Create(fBilder[Form1.karten_spieler[i]]);
     {Kartenliste.Items[i].Left := temp;
     Kartenliste.Items[i].Top := 3;}
     Kartenliste.add(tempCard);
     Canvas.Draw(temp,3,fBilder[Form1.karten_spieler[i]]);
     temp := (i+1) * temp2;
     tempCard.Free;
  end;
end;

{ TForm1 }

procedure TForm1.Arrays_Fuellen;
var
   i : Integer;
begin
    SetLength(self.karten_im_deck,36);
    for i := 1 to 36 do
    begin
       self.karten_im_deck[i] := i;
    end;
end;

procedure TForm1.BeendenClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   i : Integer;
begin
  isCreated := false;
  for i := 1 to 36 do
  begin
     fBilder[i] := TBitmap.Create;
     fBilder[i].Width:=100;
     fBilder[i].Height:=Kartenhand_anzeige.Height-2;
     fBilder[i].Canvas.Color := clWhite;
     fBilder[i].Canvas.FillRect(2,2,fBilder[i].Width-2,fBilder[i].Height-2);
     fBilder[i].Canvas.TextOut(3,3,KartenFarbe(i)+' '+KartenWert(i));
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if isCreated then
  begin
     Spielerhand.Free;
  end;
end;

procedure TForm1.FormMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowMessage(IntToStr(X)+' '+IntToStr(Y));
end;

procedure TForm1.Groupbox2Click(Sender: TObject);
begin

end;

procedure TForm1.Groupbox2MouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   i,FormLeft,FormTop : Integer;
   tempRect: TRect;
   tempPoint: TPoint;
begin
   i := Spielerhand.Kartenliste.Count-1;
   FormLeft := Left + Groupbox2.Left + Panel1.Left;
   FormTop := Top + Groupbox2.Top + Panel1.Top;
   //ShowMessage(IntToStr(X)+' '+IntToStr(Y));
   repeat
   begin
      tempPoint.x := X;
      tempPoint.y := Y;
      tempRect.Bottom := FormTop + Spielerhand.Kartenliste.Items[i].Bottom;
      tempRect.Top := FormTop + Spielerhand.Kartenliste.Items[i].Top;
      tempRect.Left :=  FormLeft + Spielerhand.Kartenliste.Items[i].Left;
      tempRect.Right := FormLeft + Spielerhand.Kartenliste.Items[i].Right;

      if PtInRect(tempRect,tempPoint) then
      begin
         ShowMessage(KartenFarbe( karten_spieler[i] )+' '+KartenWert( karten_spieler[i] )+' ist Angeklickt worden.');
         i := 0;
      end;

      if i <> 0 then
      begin
         i := i - 1;
      end;

   end until (i = 0);
end;

procedure TForm1.Karten_zeichnen;
var
   temp,temp2,i,Prozent1,Prozent2 : Integer;
   tempObject: TObject;
   tempCard: TCard;
begin
  Kartenhand_anzeige.Canvas.Clear;
  //Kartenhand_anzeige.Canvas.;
  Kartenhand_anzeige.Canvas.Brush.Color := clFuchsia;
  Kartenhand_anzeige.Picture.Bitmap.TransparentColor := clFuchsia;
  Kartenhand_anzeige.Picture.Bitmap.Transparent := true;
  Kartenhand_anzeige.Canvas.FillRect(0,0,Kartenhand_anzeige.Width,Kartenhand_anzeige.Height);
  if isKartenlisteCreated then
  begin
     Kartenliste.Free;
     isKartenlisteCreated := false;
  end;

     Kartenliste := TCardList.create;
     isKartenlisteCreated := True;


  temp := 0;
  Prozent1 := 101 div (Length(karten_spieler)+1);
  temp2 := (Kartenhand_anzeige.Width + 10) div 101 * (Prozent1-1);

  for i := 0 to Length(karten_spieler) do
  begin
     tempCard := TCard.Create(fBilder[karten_spieler[i]]);
     
     Kartenliste.add(tempCard);
     
     Kartenliste.Items[i].Left := temp;
     Kartenliste.Items[i].Top := 2;
     Kartenliste.Items[i].Bottom := 2 + fBilder[karten_spieler[i]].Height;
     Kartenliste.Items[i].Right := temp + fBilder[karten_spieler[i]].Width;
     Kartenhand_anzeige.Canvas.Draw(temp,2,fBilder[karten_spieler[i]]);
     temp := (i+1) * temp2;
     tempCard.Free;
  end;

end;

procedure TForm1.Karten_austeilen;
//In dieser Prozedur werden die Karten fr beide Spieler ausgewhlt
//jeder Spieler (zZ. nur ein Spieler & Computer Gegner) bekommt 6 Karten (0..5)
//die restlichen Karten bleiben im Deck
var
   zahl : Integer;
   spieler, gegner, trumpf1: Boolean;
begin
   zahl := 0;
   SetLength(karten_spieler,0);
   SetLength(karten_gegner,0);
   
   
   //Die Drei Schleifen Variablen
   //Solange diese auf 'True' sind werden die while-Schleifen ausgefhrt
   spieler := true;
   gegner := true;
   trumpf1 := true;
   
   while spieler do
   begin
       Randomize;
       zahl := random(36) + 1;
       if inArray(karten_im_deck,zahl) AND not(inArray(karten_spieler, zahl)) then
       begin
           karten_spieler := AddArrayElement(karten_spieler,zahl);
           karten_im_deck := DeleteArrayElement(karten_im_deck, zahl);
       end;
       if length(karten_spieler) = 9 then begin SetLength(karten_spieler, 8); spieler := false; end;
   end;
   
   while gegner do
   begin
       Randomize;
       zahl := random(36) + 1;
       if (inArray(karten_im_deck,zahl)) AND ((not inArray(karten_gegner, zahl))) then
       begin
           karten_gegner := AddArrayElement(karten_gegner,zahl);
           karten_im_deck := DeleteArrayElement(karten_im_deck, zahl);
       end;
       if length(karten_gegner) = 6 then begin SetLength(karten_gegner, 5); gegner := false; end;
   end;
   
   while trumpf1 do
   begin
       Randomize;
       zahl := random(36) + 1;
       if (inArray(karten_im_deck,zahl)) AND ((not inArray(karten_gegner, zahl))) AND not(inArray(karten_spieler, zahl)) then
       begin
           trumpf := zahl;
           karten_im_deck := DeleteArrayElement(karten_im_deck, zahl);
           trumpf1 := false;
       end;
   end;
end;

procedure TForm1.Kartenhand_anzeigeMouseDown(Sender: TOBject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   i,FormLeft,FormTop : Integer;
   tempRect: TRect;
   tempPoint: TPoint;
begin
   Memo1.Clear;
   i := Kartenliste.Count-1;
   FormLeft := Left + Groupbox2.Left + Panel1.Left;
   FormTop := Top + Groupbox2.Top + Panel1.Top;
   //ShowMessage(IntToStr(X)+' '+IntToStr(Y));
   repeat
   begin
      tempPoint.x := X;
      tempPoint.y := Y;
      tempRect.Bottom := Kartenliste.Items[i].Bottom;
      tempRect.Top := Kartenliste.Items[i].Top;
      tempRect.Left :=  Kartenliste.Items[i].Left;
      tempRect.Right := Kartenliste.Items[i].Right;
      Memo1.Lines.Add(IntToStr(i)+'. Mouse X/Y = '+IntToStr(X)+'/'+IntToStr(Y)+
                      '; B/T/L/R = '+IntToStr(tempRect.Bottom)+'/'+IntToStr(tempRect.Top)+'/'+IntToStr(tempRect.Left)+'/'+IntToStr(tempRect.Right)+
                      '; B/T/L/R = '+IntToStr(Kartenliste.Items[i].Bottom)+'/'+IntToStr(Kartenliste.Items[i].Top)+'/'+IntToStr(Kartenliste.Items[i].Left)+'/'+IntToStr(Kartenliste.Items[i].Right));
      if PtInRect(tempRect,tempPoint) then
      begin
         ShowMessage(KartenFarbe( karten_spieler[i] )+' '+KartenWert( karten_spieler[i] )+' ist Angeklickt worden.');
         i := -1;
      end;

      if i <> -1 then
      begin
         i := i - 1;
      end;

   end until (i = -1);
end;

procedure TForm1.StartenClick(Sender: TObject);
begin
  arrays_fuellen;
  Karten_austeilen;
  Karten_zeichnen;
  {*if isCreated then
  begin
       Spielerhand.free;
       isCreated := false;
  end;
  Spielerhand:=TKartenhand.Create(Self);
  Spielerhand.DoubleBuffered := true;
  Spielerhand.Parent:=self.Panel1;
  Spielerhand.Width:=Panel1.Width;
  Spielerhand.Height:=Panel1.Height;
  isCreated := true;
  
  Spielerhand.Canvas.Clear;
  Spielerhand.Canvas.Brush.Color:=clwhite;
  Spielerhand.Canvas.FillRect(BoundsRect);
  //Spielerhand.Canvas.TextOut(0,0,'Spieler:' + #13 + ArrayToString(karten_spieler) + KartenFarbe(karten_spieler[0]) + KartenWert(karten_spieler[0]));
  //Spielerhand.Canvas.Lock;
  Kartenhand_anzeige.Canvas.Brush.Color := clWhite;
  Kartenhand_anzeige.Canvas.FillRect(BoundsRect);*}
end;


initialization
  {$I main.lrs}

end.

